# have a great day if you stop editing my files

execute as @a[hasitem={item=js:health}] run scriptevent js:hp_pickup
effect @a saturation 1 255 true
execute if score @a[tag=Host,c=1] sgn_req_en matches ..6 run effect @e[family=required] bad_omen 1 0 true

# FRIENDLY FIRE 
execute as @a[tag=Host,tag=friendly_fire_on,scores={gamestart=1},tag=!ffa] run tag @a[scores={lobby=!1}] remove projectileDamageFalse
execute as @a[tag=Host,tag=friendly_fire_off,scores={gamestart=1},tag=!ffa] run tag @a add projectileDamageFalse
tag @a[scores={lobby=1}] add projectileDamageFalse
execute as @a[tag=Host,tag=ffa] run tag @a remove projectileDamageFalse


# SGN
execute as @a[tag=Host,tag=sgn] at @s run function sgn/sgn_music_score
execute as @a[tag=Host,tag=sgn_devastation] at @s run function sgn/sgn_music_score
execute as @a[tag=Host,tag=sgn_infinite] at @s run function sgn/sgn_music_score
execute as @a[tag=Host,tag=playing_sgn,tag=!sgn_infinite] at @s run function sgn/sgn_required_enemies
execute as @a[tag=Host,tag=!sgn,tag=!sgn_infinite,tag=!sgn_devastation] at @s run scoreboard players set @s sgn_music -1
execute as @a[tag=!playing_sgn] at @s run scoreboard players set @s sgn_music -1
execute as @a[tag=Host,tag=!sgn,tag=!sgn_infinite,tag=!sgn_devastation] at @s run scoreboard players set @s sgn_req_en -1

execute as @a[tag=Host] at @s run tag @a[tag=!Host] add Member
tag @a[tag=!Member] add Host
tag @a[tag=Member] remove Host

function Cmd.ammoStart
function game_system/xp

# FFA
execute as @a[tag=Host,tag=ffa] at @s run function game_system/ffa_score_display
execute as @a[tag=Host,tag=!ffa] at @s run spawnpoint @a 2010 11 23
execute as @a[tag=Host,tag=!ffa] at @s run event entity @a[x=57,y=5,z=76,dx=-91,dy=35,dz=75,tag=!in_tutorial] js:not_in_ffa

execute as @a[tag=Host,tag=playing_sgn,tag=!sgn_infinite] at @s run titleraw @a title {"rawtext":[{"text":"§l§b Required\nGrowths\nRemaining:\n §e"}, {"score":{"name":"@a[tag=Host]","objective":"sgn_req_en"}}]}
fog @a push js:fog_super_growth_nest SGN

# Tutorial
execute as @e[family=no_ai,type=!js:scp682_tutorial] at @s run tp @s ~~~ 180 0
execute as @e[type=js:buff_totem,c=1] run function buff_totem_buff

tag @a[scores={lobby=1}] add infinite_ammo
tag @a[scores={lobby=0}] remove infinite_ammo

effect @a[tag=has_speed] speed 1 1 true
effect @a[tag=has_speed_lv2] speed 1 2 true
effect @a[tag=has_armour3] resistance 1 0 true

#Hook
execute as @e[family=no_ai] at @s run ride @e[type=js:meathook,r=3] start_riding @s
execute as @e[family=scp682] at @s run ride @e[type=js:meathook,r=3] start_riding @s

#Counter
scoreboard players set @a[tag=Host] playercount 0
execute as @a[tag=in_game] at @s run scoreboard players add @a[tag=Host] playercount 1
execute as @a[scores={gamestart=1},tag=!playing_sgn] at @s run execute as @s[scores={playercount=0}] at @s run function game_system/game_end
execute as @a[scores={gamestart=1},tag=!buff_totem] at @s run execute as @s[tag=won] at @s run function game_system/game_end_won
execute as @a[scores={kills=20..}] at @s run execute as @a[scores={gamestart=1},tag=Host,tag=ffa] at @s run function game_system/game_end_ffa
execute as @a[scores={gamestart=1},tag=buff_totem] at @s run execute as @s[tag=won] at @s run function game_system/game_end_won_buff_totem
execute as @a[scores={gamestart=1},tag=playing_sgn] at @s run execute as @s[scores={playercount=0}] at @s run function game_system/game_end_sgn

execute as @a[scores={gamestart=1},tag=sgn_infinite] at @s run execute as @s[scores={playercount=0}] at @s run function game_system/game_end_sgn

#Lobby Effects
effect @a[scores={lobby=1}] regeneration 1 255 true
effect @a[scores={lobby=1}] saturation 1 255 true
execute as @a[tag=infinite_ammo] at @s run function Cmd.ammo_refill
execute as @a[tag=Host,tag=infinite_ammo2] at @s run execute as @a at @s run function Cmd.ammo_refill
execute as @a[x=2012,y=22,z=5,r=530] at @s run scoreboard players set @s lobby 1
execute as @a[x=2012,y=22,z=5,rm=531] at @s run scoreboard players set @s lobby 0
execute as @a[m=!spectator] at @s run kill @s[y=-40,dy=41]

execute as @a[tag=Host,tag=!pass] at @s run summon js:tutorial

gamerule dodaylightcycle false

# Delayer
execute as @a[tag=Host] at @s run execute as @s[tag=delayer] at @s run scoreboard players add @s timer_delay 1
execute as @a[tag=delayer,tag=start,scores={timer_delay=39..}] at @s run function game_system/start_function
execute as @a[tag=end,scores={timer_delay=39..}] at @s run function game_system/end_function
execute as @a[tag=Host,scores={timer_delay=40..}] at @s run tag @s remove delayer
execute as @a[tag=Host,scores={timer_delay=40..}] at @s run scoreboard players set @s timer_delay 1

# MRX-15
execute as @p[scores={mrx15=0}] at @s run replaceitem entity @s slot.hotbar 1 js:mrx15_empty 1 0 {"minecraft:item_lock":{"mode":"lock_in_slot"}}
execute as @p[scores={mrx15=0}] at @s run scoreboard players set @p mrx15 -1
execute as @p[scores={mrx15=..-1}] at @s run scoreboard players set @s mrx15 -1

# XR-A5
execute as @p[scores={xra5=0}] at @s run replaceitem entity @s slot.hotbar 2 js:xra5_empty 1 0 {"minecraft:item_lock":{"mode":"lock_in_slot"}}
execute as @p[scores={xra5=0}] at @s run scoreboard players set @p xra5 -1
execute as @p[scores={xra5=..-1}] at @s run scoreboard players set @s xra5 -1

# Project 80
execute as @p[scores={project80=0}] at @s run replaceitem entity @s slot.hotbar 3 js:project80_empty 1 0 {"minecraft:item_lock":{"mode":"lock_in_slot"}}
execute as @p[scores={project80=0}] at @s run scoreboard players set @p project80 -1
execute as @p[scores={project80=..-1}] at @s run scoreboard players set @s project80 -1

# NG-L7
execute as @p[scores={ngl7=0}] at @s run replaceitem entity @s slot.hotbar 4 js:ngl7_empty 1 0 {"minecraft:item_lock":{"mode":"lock_in_slot"}}
execute as @p[scores={ngl7=0}] at @s run scoreboard players set @p ngl7 -1
execute as @p[scores={ngl7=..-1}] at @s run scoreboard players set @s ngl7 -1

# PRAETEREO
execute as @p[scores={praetereo=0}] at @s run replaceitem entity @s slot.hotbar 5 js:praetereo_empty 1 0 {"minecraft:item_lock":{"mode":"lock_in_slot"}}
execute as @p[scores={praetereo=0}] at @s run scoreboard players set @p praetereo -1
execute as @p[scores={praetereo=..-1}] at @s run scoreboard players set @s praetereo -1

# PRAEDO
execute as @p[scores={praedo=0}] at @s run replaceitem entity @s slot.hotbar 6 js:praedo_empty 1 0 {"minecraft:item_lock":{"mode":"lock_in_slot"}}
execute as @p[scores={praedo=0}] at @s run scoreboard players set @p praedo -1
execute as @p[scores={praedo=..-1}] at @s run scoreboard players set @s praedo -1

gamerule commandblocksenabled true
execute as @p[scores={praedo_overheat=60..}] at @s run playanimation @s animation.praedo_overheat_10 JS 0 "q.is_alive" praedo_overheat
execute as @p[scores={praedo_overheat=54..59}] at @s run playanimation @s animation.praedo_overheat_9 JS 0 "q.is_alive" praedo_overheat
execute as @p[scores={praedo_overheat=48..53}] at @s run playanimation @s animation.praedo_overheat_8 JS 0 "q.is_alive" praedo_overheat
execute as @p[scores={praedo_overheat=42..47}] at @s run playanimation @s animation.praedo_overheat_7 JS 0 "q.is_alive" praedo_overheat
execute as @p[scores={praedo_overheat=36..41}] at @s run playanimation @s animation.praedo_overheat_6 JS 0 "q.is_alive" praedo_overheat
execute as @p[scores={praedo_overheat=30..35}] at @s run playanimation @s animation.praedo_overheat_5 JS 0 "q.is_alive" praedo_overheat
execute as @p[scores={praedo_overheat=24..29}] at @s run playanimation @s animation.praedo_overheat_4 JS 0 "q.is_alive" praedo_overheat
execute as @p[scores={praedo_overheat=18..23}] at @s run playanimation @s animation.praedo_overheat_3 JS 0 "q.is_alive" praedo_overheat
execute as @p[scores={praedo_overheat=12..17}] at @s run playanimation @s animation.praedo_overheat_2 JS 0 "q.is_alive" praedo_overheat
execute as @p[scores={praedo_overheat=6..11}] at @s run playanimation @s animation.praedo_overheat_1 JS 0 "q.is_alive" praedo_overheat
execute as @p[scores={praedo_overheat=..0}] at @s run playanimation @s animation.praedo_overheat_0 JS 0 "q.is_alive" praedo_overheat